﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Pivot.Core;
using Telerik.Pivot.Core.Aggregates;

namespace _821332
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.radPivotGrid1.ColumnGroupDescriptions.Add(new DateTimeGroupDescription() { PropertyName = "OrderDate", Step = DateTimeStep.Year, GroupComparer = new GroupNameComparer() });
            this.radPivotGrid1.ColumnGroupDescriptions.Add(new DateTimeGroupDescription() { PropertyName = "OrderDate", Step = DateTimeStep.Month, GroupComparer = new MyComparer() });

            this.radPivotGrid1.RowGroupDescriptions.Add(new PropertyGroupDescription() { PropertyName = "EmployeeID" });

            this.radPivotGrid1.AggregateDescriptions.Add(new PropertyAggregateDescription() { PropertyName = "Freight", AggregateFunction = AggregateFunctions.Average });

            NwindDataSet dataset = new NwindDataSet();
            NwindDataSetTableAdapters.OrdersTableAdapter adapter = new NwindDataSetTableAdapters.OrdersTableAdapter();
            adapter.Fill(dataset.Orders);

            this.radPivotGrid1.DataSource = dataset;
            this.radPivotGrid1.DataMember = "Orders";
        }
    }

    public class MyComparer : GroupComparer
    {
        System.Collections.Hashtable myOrder = new System.Collections.Hashtable();

        public MyComparer()
        {
            myOrder.Add("January", 7);
            myOrder.Add("February", 8);
            myOrder.Add("March", 9);
            myOrder.Add("April", 10);
            myOrder.Add("May", 11);
            myOrder.Add("June", 12);
            myOrder.Add("July", 1);
            myOrder.Add("August", 2);
            myOrder.Add("September", 3);
            myOrder.Add("October", 4);
            myOrder.Add("November", 5);
            myOrder.Add("December", 6);
        }

        public override int CompareGroups(IAggregateResultProvider results, IGroup left, IGroup right, PivotAxis axis)        
        {
            var leftName = left.Name;
            var rightName = right.Name;
            IComparable leftComparable = leftName as IComparable;
            if (leftComparable != null)
            {
                if (rightName == null)
                {
                    return -1;
                }
                else if (leftName.GetType() == rightName.GetType())
                {
                    return (int)myOrder[leftName.ToString()] < (int)myOrder[rightName.ToString()] ? -1 : 1;
                }
            }
            
            return 0;
        }

        protected override void CloneCore(Cloneable source)
        {
        }

        protected override Cloneable CreateInstanceCore()
        {
            return new MyComparer();
        }
    }
}